/********************************************************************************

  Copyright (c) 2006, Hyoung-Sun Kim.
  All Rights Reserved.

  You can contact us with
  web site <http://www.voiper.co.kr>
  e-mail <voiper@voiper.co.kr>

  This software is distributed under the terms of the BSD license

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
    * Neither the name of the <organization> nor the
      names of its contributors may be used to endorse or promote products
      derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*********************************************************************************/


/*

	<NoLockList.h>	2005-03-15,11:19

*/

#ifndef __NOLOCKLIST_H__
#define __NOLOCKLIST_H__

#include "HSDefine.h"





typedef struct
{
	void *prev;
	void *data;
	void *next;
} ChainUnit;

HS_RESULT new_ChainUnit( ChainUnit *pObj, void *pPrev, void *pData, void *pNext );
HS_RESULT delete_ChainUnit( ChainUnit *pObj, HS_RESULT (*pDeleteFunction)(void*) );



typedef struct
{
	ChainUnit	*units;
	unsigned int		size;

	HS_RESULT (*DeleteFunction)(void*);
} NoLockList;

HS_RESULT new_NoLockList( NoLockList *pObj, HS_RESULT (*pDeleteFunction)(void*) );
HS_RESULT delete_NoLockList( NoLockList *pObj );
HS_RESULT NoLockList_Clear( NoLockList *pObj );

HS_RESULT NoLockList_AttachData( NoLockList *pObj, void *pData );
ChainUnit *NoLockList_GetChain( NoLockList *pObj, unsigned int pIndex );
HS_RESULT NoLockList_DeleteChain( NoLockList *pObj, ChainUnit *pChain );
void *NoLockList_DetachData(NoLockList *pObj, unsigned int pIndex);
void *NoLockList_GetData(NoLockList *pObj, unsigned int pIndex);





#endif/*__NOLOCKLIST_H__*/

