/********************************************************************************

  Copyright (c) 2006, Hyoung-Sun Kim.
  All Rights Reserved.

  You can contact us with
  web site <http://www.voiper.co.kr>
  e-mail <voiper@voiper.co.kr>

  This software is distributed under the terms of the BSD license

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
    * Neither the name of the <organization> nor the
      names of its contributors may be used to endorse or promote products
      derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*********************************************************************************/

/*

	<UcharRing.h>		2006-01-10,19:38

*/

#ifndef __2006_01_10__19_38__UCHARRING_H__
#define __2006_01_10__19_38__UCHARRING_H__





#include "RtpDefine.h"





#define UcharRing_A(pObj)		(pObj->mData+pObj->mA)
#define UcharRing_Z(pObj)		(pObj->mData+pObj->mZ)
#define UcharRing_LA(pObj)		(pObj->mMax-pObj->mA)
#define UcharRing_LZ(pObj)		(pObj->mMax-pObj->mZ)

typedef struct
{
	HS_UCHAR *mData;

	HS_UINT mA;
	HS_UINT mZ;
	HS_UINT mMax;
	HS_UINT mSize;
} UcharRing;

HS_RESULT new_UcharRing(void *pObject,HS_UINT pMax);
UcharRing *newm_UcharRing(HS_UINT pMax);
HS_RESULT delete_UcharRing(void *pObject);
HS_RESULT deletem_UcharRing(void *pObject);

HS_RESULT UcharRing_Put(void *pObject,HS_UCHAR *pIn,HS_UINT pSize);
HS_RESULT UcharRing_ForcePut(void *pObject,HS_UCHAR *pIn,HS_UINT pSize);
HS_UCHAR *UcharRing_Get(void *pObject,HS_UINT pSize);





#define HS_RING_SIZE			20000





#endif/*__2006_01_10__19_38__UCHARRING_H__*/