/*

	<rc2.h>		2005-12-06,22:11

*/

#ifndef __2005_12_06__22_11__RC2_H__
#define __2005_12_06__22_11__RC2_H__




#define HSMalloc	malloc
#define HSFree		free



////////////////////////////////////////////////////////////////////
//#define UNRESTRICTED_KEYS
#define BYTE unsigned char
#define WORD unsigned int

#define MASK16( x )	( ( x ) & 0xFFFFUL )

#define zeroise( memory, size )		memset( memory, 0, size )

#define mgetLWord(memPtr)		\
		( ( WORD ) memPtr[ 0 ] ) | ( ( WORD ) memPtr[ 1 ] << 8 ); \
		memPtr += 2

#define mputLWord(memPtr,data)	\
		memPtr[ 0 ] = ( BYTE ) ( ( data ) & 0xFF ); \
		memPtr[ 1 ] = ( BYTE ) ( ( ( data ) >> 8 ) & 0xFF ); \
		memPtr += 2
//////////////////////////////////////////////////////////////////////
/* The size of the key in bytes and 16-bit words */
#define RC2_KEY_SIZE		128	// BYTE 128 * 8 = 1024 bit (is The Limit of Key)
#define RC2_KEY_SIZE_WORDS	( RC2_KEY_SIZE / 2 )
#define RC2_BLOCKSIZE		8

/* The RC2 key */
typedef struct {
	unsigned int key[ RC2_KEY_SIZE_WORDS ];
} RC2_KEY;

//void rc2keyInit( RC2_KEY *rc2key, const BYTE *userKey, const int length );
//void rc2encrypt( RC2_KEY *rc2key, BYTE *buffer );
//void rc2decrypt( RC2_KEY *rc2key, BYTE *buffer );

#define ROTATE_LEFT(x,n)	( ( ( x ) << n ) | ( ( x ) >> ( 16 - n ) ) )
#define ROTATE_RIGHT(x,n)	( ( ( x ) >> n ) | ( ( x ) << ( 16 - n ) ) )

#define enc(A,B,C,D,S,round,rotAmount) \
	MASK16( ROTATE_LEFT( MASK16( A + ( B & ~C ) + ( D & C ) + S[ round ] ), rotAmount ) )

#define dec(A,B,C,D,S,round,rotAmount) \
	MASK16( MASK16( ROTATE_RIGHT( A, rotAmount ) ) - ( B & ~D ) - ( C & D ) - S[ round ] )

#define encRound(A,B,C,D,S,round) \
	A = enc( A, B, D, C, S, ( round * 4 ) + 0, 1 ); \
	B = enc( B, C, A, D, S, ( round * 4 ) + 1, 2 ); \
	C = enc( C, D, B, A, S, ( round * 4 ) + 2, 3 ); \
	D = enc( D, A, C, B, S, ( round * 4 ) + 3, 5 )

#define decRound(A,B,C,D,S,round) \
	D = dec( D, A, B, C, S, ( round * 4 ) + 3, 5 ); \
	C = dec( C, D, A, B, S, ( round * 4 ) + 2, 3 ); \
	B = dec( B, C, D, A, S, ( round * 4 ) + 1, 2 ); \
	A = dec( A, B, C, D, S, ( round * 4 ) + 0, 1 )

#define addSboxes(A,B,C,D,S) \
	A += S[ D & RC2_KEY_SIZE_WORDS - 1 ]; \
	B += S[ A & RC2_KEY_SIZE_WORDS - 1 ]; \
	C += S[ B & RC2_KEY_SIZE_WORDS - 1 ]; \
	D += S[ C & RC2_KEY_SIZE_WORDS - 1 ]

#define subSboxes(A,B,C,D,S) \
	D -= S[ C & RC2_KEY_SIZE_WORDS - 1 ]; \
	D = MASK16( D ); \
	C -= S[ B & RC2_KEY_SIZE_WORDS - 1 ]; \
	C = MASK16( C ); \
	B -= S[ A & RC2_KEY_SIZE_WORDS - 1 ]; \
	B = MASK16( B ); \
	A -= S[ D & RC2_KEY_SIZE_WORDS - 1 ]; \
	A = MASK16( A )

static BYTE sBox[] = {
	0xD9, 0x78, 0xF9, 0xC4, 0x19, 0xDD, 0xB5, 0xED,
	0x28, 0xE9, 0xFD, 0x79, 0x4A, 0xA0, 0xD8, 0x9D,
	0xC6, 0x7E, 0x37, 0x83, 0x2B, 0x76, 0x53, 0x8E,
	0x62, 0x4C, 0x64, 0x88, 0x44, 0x8B, 0xFB, 0xA2,
	0x17, 0x9A, 0x59, 0xF5, 0x87, 0xB3, 0x4F, 0x13,
	0x61, 0x45, 0x6D, 0x8D, 0x09, 0x81, 0x7D, 0x32,
	0xBD, 0x8F, 0x40, 0xEB, 0x86, 0xB7, 0x7B, 0x0B,
	0xF0, 0x95, 0x21, 0x22, 0x5C, 0x6B, 0x4E, 0x82,
	0x54, 0xD6, 0x65, 0x93, 0xCE, 0x60, 0xB2, 0x1C,
	0x73, 0x56, 0xC0, 0x14, 0xA7, 0x8C, 0xF1, 0xDC,
	0x12, 0x75, 0xCA, 0x1F, 0x3B, 0xBE, 0xE4, 0xD1,
	0x42, 0x3D, 0xD4, 0x30, 0xA3, 0x3C, 0xB6, 0x26,
	0x6F, 0xBF, 0x0E, 0xDA, 0x46, 0x69, 0x07, 0x57,
	0x27, 0xF2, 0x1D, 0x9B, 0xBC, 0x94, 0x43, 0x03,
	0xF8, 0x11, 0xC7, 0xF6, 0x90, 0xEF, 0x3E, 0xE7,
	0x06, 0xC3, 0xD5, 0x2F, 0xC8, 0x66, 0x1E, 0xD7,
	0x08, 0xE8, 0xEA, 0xDE, 0x80, 0x52, 0xEE, 0xF7,
	0x84, 0xAA, 0x72, 0xAC, 0x35, 0x4D, 0x6A, 0x2A,
	0x96, 0x1A, 0xD2, 0x71, 0x5A, 0x15, 0x49, 0x74,
	0x4B, 0x9F, 0xD0, 0x5E, 0x04, 0x18, 0xA4, 0xEC,
	0xC2, 0xE0, 0x41, 0x6E, 0x0F, 0x51, 0xCB, 0xCC,
	0x24, 0x91, 0xAF, 0x50, 0xA1, 0xF4, 0x70, 0x39,
	0x99, 0x7C, 0x3A, 0x85, 0x23, 0xB8, 0xB4, 0x7A,
	0xFC, 0x02, 0x36, 0x5B, 0x25, 0x55, 0x97, 0x31,
	0x2D, 0x5D, 0xFA, 0x98, 0xE3, 0x8A, 0x92, 0xAE,
	0x05, 0xDF, 0x29, 0x10, 0x67, 0x6C, 0xBA, 0xC9,
	0xD3, 0x00, 0xE6, 0xCF, 0xE1, 0x9E, 0xA8, 0x2C,
	0x63, 0x16, 0x01, 0x3F, 0x58, 0xE2, 0x89, 0xA9,
	0x0D, 0x38, 0x34, 0x1B, 0xAB, 0x33, 0xFF, 0xB0,
	0xBB, 0x48, 0x0C, 0x5F, 0xB9, 0xB1, 0xCD, 0x2E,
	0xC5, 0xF3, 0xDB, 0x47, 0xE5, 0xA5, 0x9C, 0x77,
	0x0A, 0xA6, 0x20, 0x68, 0xFE, 0x7F, 0xC1, 0xAD
};

static int rc2_pow( int base, int exponent )
{
	int i, result = 1;

	for( i = 0; i < exponent; i++ )
		result = result * base;

	return( result );
}





#ifndef NULL
#define NULL		0x00000000
#endif





typedef struct
{
	RC2_KEY *mKey;

	unsigned char *mResult;
	unsigned int mResultLen;
} Rc2Context;

int new_Rc2Context(void *pObject);
Rc2Context *newm_Rc2Context();
int delete_Rc2Context(void *pObject);
int deletem_Rc2Context(void *pObject);

#if 0
int Rc2Context_SetKey(void *pObject,unsigned char *pKey,unsigned int pByteLen);
#else
int Rc2Context_SetKey(void *pObject,unsigned char *pKey,unsigned int pByteLen,unsigned int pEffective);
#endif

int Rc2Context_EncryptEcb(void *pObject, unsigned char *pData, unsigned int pLen);
int Rc2Context_DecryptEcb(void *pObject, unsigned char *pData, unsigned int pLen);
int Rc2Context_EncryptCbc(void *pObject, unsigned char *pIv, unsigned char *pData, unsigned int pLen);
int Rc2Context_DecryptCbc(void *pObject, unsigned char *pIv, unsigned char *pData, unsigned int pLen);
int Rc2Context_EncryptOfb(void *pObject, unsigned char *pIv, unsigned char *pData, unsigned int pLen);
int Rc2Context_DecryptOfb(void *pObject, unsigned char *pIv, unsigned char *pData, unsigned int pLen);
int Rc2Context_EncryptCfb(void *pObject, unsigned char *pIv, unsigned char *pData, unsigned int pLen);
int Rc2Context_DecryptCfb(void *pObject, unsigned char *pIv, unsigned char *pData, unsigned int pLen);
unsigned char *Rc2Context_GetResult(void *pObject, unsigned int *pLen);





#endif/*__2005_12_06__22_11__RC2_H__*/